#ifndef __AUTO_H_
#define __AUTO_H_

#define bool  int
#define true  (1)
#define false (0)

#define LOG

/* Macroses for log output */
#ifdef LOG
#include "stdio.h"
#define PRINT_LEVEL { for(int l = 0; l < log_level; l++) \
                    { printf("\t"); }}
#define LOG_AUTO_ENTER(a) { log_stack[log_stack_pos++] = a; \
                          log_level++; PRINT_LEVEL; \
           printf("| Automa A%i is in state %i\n", a, y##a);}
#define LOG_AUTO_EXIT(a) { log_stack_pos--; log_level--;}
#define LOG_AUTO_CHANGE(a) { PRINT_LEVEL; \
       printf("| Automa A%i switched to state %i\n", a, y##a);}
#define LOG_X(a, c) { int res = (c); PRINT_LEVEL; \
     printf("> %s invoked by A%i with result %s\n", #a, \
     log_stack[log_stack_pos - 1], (res == 0) ? "false" : \
     "true"); return res;}
#define LOG_Z(a) { PRINT_LEVEL; \
      printf("< %s invoked by A%i\n", \
      #a, log_stack[log_stack_pos - 1]);}
#define LOG_MAX_STACK 16
#else
#define PRINT_LEVEL       
#define LOG_AUTO_ENTER(a) 
#define LOG_AUTO_EXIT(a)  
#define LOG_AUTO_CHANGE(a)
#define LOG_X(a, c) return (c)
#define LOG_Z(a) 
#endif

/* Automata */
void A0(void); 
void A1(void); 
void A2(void); 
void A3(void); 
void A4(void); 
void A5(void); 

 
/* Automata state */
extern int y0;
extern int y1;
extern int y2;
extern int y3;
extern int y4;
extern int y5;

/* Automata 0 events */
bool x0_1(void);
bool x0_2(void);
bool x0_3(void);
bool x0_4(void);
bool x0_5(void);
bool x0_6(void);
bool x0_7(void);
bool x0_8(void);

/* Automata 1 events */
bool x1_1(void);
bool x1_2(void);
bool x1_3(void);
bool x1_4(void);
bool x1_5(void);
bool x1_6(void);
bool x1_7(void);

/* Automata 2 events */
bool x2_1(void);
bool x2_2(void);
bool x2_3(void);
bool x2_4(void);

/* Automata 3 events */
bool x3_1(void);
bool x3_2(void);
bool x3_3(void);
bool x3_4(void);
bool x3_5(void);

/* Automata 4 events */
bool x4_1(void);
bool x4_2(void);
bool x4_3(void);
bool x4_4(void);
bool x4_5(void);
bool x4_6(void);
bool x4_7(void);

/* Automata 5 events */
bool x5_1(void);
bool x5_2(void);
bool x5_3(void);
bool x5_4(void);

/* Automata 0 actions */
void z0_1(void);
void z0_2(void);
void z0_3(void);
void z0_4(void);
void z0_5(void);
void z0_6(void);

/* Automata 1 actions */
void z1_1(void);
void z1_2(void);

/* Automata 2 actions */
void z2_1(void);
void z2_2(void);
void z2_3(void);

/* Automata 3 actions */
void z3_1(void);
void z3_2(void);
void z3_3(void);

/* Automata 4 actions */
void z4_1(void);
void z4_2(void);
void z4_3(void);
void z4_4(void);
void z4_5(void);

/* Automata 5 actions */
void z5_1(void);
void z5_2(void);
void z5_3(void);

#ifdef LOG
extern int log_level;
extern int log_stack[LOG_MAX_STACK];
extern int log_stack_pos;
#endif

#endif
