#include "auto.h"
#include "supp.h"

#include <fcntl.h>
#include <stdio.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/poll.h>

int retries;

int timer;

PACKET snd, rcv;

char data[DATA_SIZE];

int data_len = 0;

bool error = true;

bool timedout;

bool old_pack;

unsigned int port;

int sock = -1;

struct sockaddr_in self;
struct sockaddr_in other;

char *to_adr;

bool init(void) 
{
    snd.to_port = port;
    snd.from_port = port;
    error = false;
    if ((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_IP)) < 0)
        error = true; 
}

bool end(void) 
{
    close(sock);
}

bool listen(void) 
{
    memset(&self, 0, sizeof(self));
    self.sin_family = AF_INET;
    self.sin_addr.s_addr = htonl(INADDR_ANY);
    self.sin_port = htons(port);

    if (bind(sock, (struct sockaddr *) &self, sizeof(self)) < 0)
        error = true;

    return !error;
}

bool send(void) 
{
    memcpy(snd.data, data, DATA_SIZE);
    snd.length = data_len;
    snd.id1++;
    snd.id2 = rcv.id1;
    if (sendto(sock, (void *)(&snd), PACKET_SIZE, 0,
               (struct sockaddr *) &other,
               sizeof(other)) != PACKET_SIZE)
    {
        error = true;
    }
     
    return error;
}

bool check_data(void)
{
    pollfd p;
    memset(&p, 0, sizeof(p));
    p.fd = sock;
    p.events = POLLIN;

    if (poll(&p, 1, 0) > 0)
        return recive();

    return false;
}

bool wait_data(void)
{
    pollfd p;
    memset(&p, 0, sizeof(p));
    p.fd = sock;
    p.events = POLLIN;
    timedout = false;

    if (poll(&p, 1, NET_TIMEOUT) > 0)
        return recive();

    timedout = true;
    return false;
}

bool recive(void) 
{ 
    int clientlen = sizeof(other);
    if (recvfrom(sock, (void *)(&rcv), sizeof(rcv), 0,
                 (struct sockaddr *) &other,
                 &clientlen) < 0)
    {
        error = true;
        return !error;
    }

    memcpy(data, rcv.data, DATA_SIZE);
    data_len = rcv.length;

//    if (rcv.id1 != snd.id2)
//      error = true;

    return !error;
}

void send_rst(void) 
{
    snd.flags = FLAG_RST;
    send(); 
}

void send_syn(void) 
{
    other.sin_family = AF_INET;                  /* Internet/IP */
    other.sin_addr.s_addr = inet_addr(to_adr);  /* IP address */
    other.sin_port = htons(port);       /* server port */

    snd.flags = FLAG_SYN;
    snd.id1 = 100;
    send(); 
}

void send_syn_ack(void) 
{
    snd.flags = (FLAG_SYN | FLAG_ACK);
    snd.id1 = 100;
    to_adr = inet_ntoa(other.sin_addr);
    send();
}

void send_fin(void) 
{
    snd.flags = FLAG_FIN;
    send(); 
}

void send_ack(void) 
{ 
    snd.flags = FLAG_ACK;
    send();
}

void send_data(void) 
{
    snd.flags = 0;
    send(); 
}
